// toShare inoutboards.js
'use strict';
// uses rest, tooltip

const sectioninoutboard = document.querySelector('.inoutboard');
const buttonNew = sectioninoutboard.querySelector('button.new');
const buttonUp = sectioninoutboard.querySelector('button.up');
const buttonDown = sectioninoutboard.querySelector('button.down');
const tableInoutboard = sectioninoutboard.querySelector('table');
const tbodyInoutboard = sectioninoutboard.querySelector('tbody');
const trTemplateInoutboard = tbodyInoutboard.firstElementChild.cloneNode(true);
const divEditLayer = document.querySelector('div.edit-layer');
const buttonCancel = divEditLayer.querySelector('button.cancel');
const inputBoardId = divEditLayer.querySelector('input.board-id');
const inputBoardName = divEditLayer.querySelector('input.board-name');
const checkboxDisable = divEditLayer.querySelector('input.disable');
const labelDisable = divEditLayer.querySelector('label.disable');
const buttonAdd = divEditLayer.querySelector('button.add');
const buttonFix = divEditLayer.querySelector('button.fix');
const buttonDel = divEditLayer.querySelector('button.del');
const UNSELECT = -1;
let memoMouseOutside = false;
let orderStartIndex = UNSELECT;
let orderEndIndex = UNSELECT;

async function updateInoutboardList(){
	await atsInoutboards.restGet(WITHDISABLED);
	tbodyInoutboard.innerHTML = '';
	for(const atsInoutboard of atsInoutboards.data){
		const aTag = document.createElement('a');
		aTag.href = 'member';
		aTag.innerText = '(編集)構成員';
		aTag.hash = atsInoutboard.board_id;
		const trInoutBoard = trTemplateInoutboard.cloneNode(true);
		trInoutBoard.dataset.boardId = atsInoutboard.board_id;
		if(atsInoutboard.disable){trInoutBoard.classList.add('disable');}
		const td = trInoutBoard.querySelectorAll('td');
		td[0].innerText = atsInoutboard.board_name;
		td[1].innerText = '';
		td[1].appendChild(aTag);
		td[2].textContent = (atsInoutboard.disable)? '非表示' : '';

		td[0].addEventListener('click', onTdInoutboardClick);
		td[2].addEventListener('click', onTdInoutboardClick);
		td[3].addEventListener('click', onTdOrderClick);
		tbodyInoutboard.appendChild(trInoutBoard);
	}
}

function redrawSelected(){
	buttonUp.disabled = (orderStartIndex===UNSELECT)||(orderStartIndex===0);
	buttonDown.disabled = (orderEndIndex===UNSELECT)||(orderEndIndex===tbodyInoutboard.rows.length-1);
	for(const tbodyTr of tbodyInoutboard.querySelectorAll('tr')){
		if(tbodyTr.classList.contains('select')){tbodyTr.classList.remove('select');}
	}
	if(orderStartIndex != UNSELECT){
		for(let index=orderStartIndex; index <= orderEndIndex; index++){
			tbodyInoutboard.rows[index].classList.add('select');
		}
	}
}

function onNewEdit(){
	for(const tbodyTr of tbodyInoutboard.querySelectorAll('tr')){
		if(tbodyTr.classList.contains('current')){tbodyTr.classList.remove('current');}
	}
	divEditLayer.style.display = 'flex';
	inputBoardId.value = '0';
	inputBoardName.value = '';
	inputBoardName.focus();
	checkboxDisable.style.visibility = 'hidden';
	labelDisable.style.visibility = 'hidden';
	buttonAdd.disabled = true;
	buttonFix.disabled = true;
	buttonDel.disabled = true;
}

async function onOrderExecute(){
	let boardIds = [];
	for(let index =orderStartIndex; index <= orderEndIndex; index++){
		boardIds.push(atsInoutboards.data[index].board_id);
	}
	switch(event.target){
		case buttonUp:{
			boardIds.push(atsInoutboards.data[orderStartIndex-1].board_id);
			try{
				await atsInoutboards.restOrderPut(boardIds)
				orderStartIndex -=1;
				orderEndIndex -=1;
			}catch(e){confirm(e.message);}
			break;
		}
		case buttonDown:{
			boardIds.unshift(atsInoutboards.data[orderEndIndex+1].board_id);
			try{
				await atsInoutboards.restOrderPut(boardIds)
				orderStartIndex +=1;
				orderEndIndex +=1;
			}catch(e){confirm(e.message);}
			break;
		}
		default: confirm('onExecute tagert unknown');
	}
	await updateInoutboardList();
	redrawSelected();
}

function onTdInoutboardClick(event){
	orderStartIndex = UNSELECT;
	orderEndIndex = UNSELECT;
	redrawSelected();
	if((event.currentTarget.parentElement.tagName != 'A')&(!event.currentTarget.parentElement.classList.contains('current'))){
		for(const tbodyTr of tbodyInoutboard.querySelectorAll('tr')){
			if(tbodyTr.classList.contains('current')){tbodyTr.classList.remove('current');}
		}
		event.currentTarget.parentElement.classList.add('current');
		divEditLayer.style.display = 'flex';
		const atsInoutboard = atsInoutboards.findField('board_id', Number(event.currentTarget.parentElement.dataset.boardId));
		inputBoardId.value = atsInoutboard.board_id;
		inputBoardName.value = atsInoutboard.board_name;
		inputBoardName.select();
		inputBoardName.focus();
		checkboxDisable.style.visibility = 'visible';
		labelDisable.style.visibility = 'visible';
		checkboxDisable.checked = (atsInoutboard.disable===1);
		buttonAdd.disabled = true;
		buttonFix.disabled = true;
		buttonDel.disabled = false;
	}else{
		event.currentTarget.parentElement.classList.remove('current');
		divEditLayer.style.display = 'none';
	}
}

function onTdOrderClick(event){
	let index = event.currentTarget.parentElement.rowIndex -1;
	if((orderStartIndex > index)||(orderStartIndex===UNSELECT)){
		orderStartIndex = index;
		orderEndIndex = index;
	}else if(orderStartIndex===index){
		orderStartIndex = UNSELECT;
		orderEndIndex = UNSELECT;
	}else if(orderStartIndex < index){
		orderEndIndex = index;
	};
	redrawSelected();
}

function onOutsideClick(event){
	if(event.currentTarget===event.target){
		if(memoMouseOutside){
			onCancel();
		}else{
			 memoMouseOutside = true;
		}
	}else{
		memoMouseOutside = false;
	}
}
function onCancel(){
	for(const tbodyTr of tbodyInoutboard.querySelectorAll('tr')){
		if(tbodyTr.classList.contains('current')){tbodyTr.classList.remove('current');}
	}
	divEditLayer.style.display = 'none';
}
function onInoutboardModified(){
	if(Number(inputBoardId.value)===0){
		buttonAdd.disabled = (inputBoardName.value==='');
		buttonFix.disabled = true;
		buttonDel.disabled = true;
	}else{
		// fix or del
		buttonAdd.disabled = true;
		buttonFix.disabled = false;
		buttonDel.disabled = false;
	}
}
async function onExecute(event){
	switch(event.target){
		case buttonAdd:{
			try{
				await atsInoutboards.restPost(
					inputBoardName.value
				)
			}catch(e){confirm(e.message);}
			break;
		}
		case buttonFix:{
			try{
				await atsInoutboards.restPut(
					Number(inputBoardId.value),
					inputBoardName.value,
					checkboxDisable.checked ? 1: 0
				)
			}catch(e){confirm(e.message);}
			break;
		}
		case buttonDel:{
			try{
				await atsInoutboards.restDelete(
					Number(inputBoardId.value)
				)
			}catch(e){confirm(e.message);}
			break;
		}
		default: confirm('onExecute tagert unknown');
	}
	divEditLayer.style.display = 'none';
	updateInoutboardList();
}

tbodyInoutboard.innerHTML = '';
atsConfiguration.reflection();
updateInoutboardList();
divEditLayer.addEventListener('mousedown', onOutsideClick);
divEditLayer.addEventListener('mouseup', onOutsideClick);
buttonNew.addEventListener('click', onNewEdit);
buttonUp.addEventListener('click', onOrderExecute);
buttonDown.addEventListener('click', onOrderExecute);
buttonCancel.addEventListener('click', onCancel);
inputBoardName.addEventListener('input', onInoutboardModified);
checkboxDisable.addEventListener('change', onInoutboardModified);
buttonAdd.addEventListener('click', onExecute);
buttonFix.addEventListener('click', onExecute);
buttonDel.addEventListener('click', onExecute);
